/********************************************************************
		The instruction system of HD44780.

		ACMMI LTD.
		Writen by Minyuan Lu.    13/11/2000
********************************************************************/
//#define BUSDELAY delaytime(TIMES2)

void WriteInst(BYTE byInstruction)
{   	/* instruction write */
	P2_0=0;				/* RS=0,R/W=0,E=0 */
	P2_1=0;
	P2_2=0;
	BUSDELAY;	
	P0=byInstruction;	/* put instruction */
	BUSDELAY;
	P2_0=1;				/* RS=0,R/W=0,E=1, */
	P2_1=0;
	P2_2=0;
	BUSDELAY;
	P2_0=0;				/* RS=0,R/W=0,E=0 */
	P2_1=0;
	P2_2=0;
}

void WriteData(BYTE byData)
{   	/* data write        */
	P2_0=0;				/* RS=1,R/W=0,E=0 */
	P2_1=0;
	P2_2=1;
	BUSDELAY;	
	P0=byData;			/* put data */
	BUSDELAY;
	P2_0=1;			  	/* RS=1,R/W=0,E=1 */
	P2_1=0;					
	P2_2=1;
	BUSDELAY;
	P2_0=0;				/* RS=1,R/W=0,E=0 */
	P2_1=0;			
	P2_2=1;
}
/*
void ClearDisplay(void)
{
	DELAY;
	WriteInst(0x01);
	delaytime(0x0100);
}

void ReturnHome(void)
{
	DELAY;
	WriteInst(0x02);
	delaytime(0x0100);
}
*/
void EntryModeSet(BYTE byInst)
{
	DELAY;
	WriteInst((byInst&0x03)|0x04);
}

void DisplayControl(BYTE byInst)
{
	DELAY;
	WriteInst((byInst&0x07)|0x08);
}
/*
void CursorDisplayShift(BYTE byInst)
{
	DELAY;
	WriteInst((byInst&0x0f)|0x10);
}
*/
void FunctionSet(BYTE byInst)
{
	DELAY;
	WriteInst((byInst&0x1f)|0x20);
}

void SetCGRAMAddress(BYTE byInst)
{
	DELAY;
	WriteInst((byInst&0x3f)|0x40);
}

void SetDDRAMAddress(BYTE byInst)
{
	DELAY;
	WriteInst(byInst|0x80);
}
/*
void WriteRAM(BYTE byData)
{
	DELAY;
	WriteData(byData);
}
*/
