#include "RW1603.C51" 
//#define CONTLPORT XBYTE[0x8007] 

void delaytime (unsigned int TIMES)
{
 for(;TIMES>0;TIMES--);
}

void InitRW1603(void)
{
//	CONTLPORT=0X80;	
	MCU_Init();
	I2C_Init();
//	I2C_Send(0x7e);
	WriteInst(0x38);
	delaytime(0x1000);
	WriteInst(0x38);
	delaytime(0x0100);
	WriteInst(0x38);
 	delaytime(0x0010);
//	ClearDisplay;
	delaytime(0x0100);
	FunctionSet(0x38);	  	//DL=1: 8 bits; N=1: 2 line; F=0: 5 x 8dots
//	DisplayControl(0x0c);	// D=C=B=0; display off; cursor off;  blinking off;
	EntryModeSet(0x06);		// I/D	=1: Increment by 1; S=0: No shift
	DisplayControl(0x0c);	// display on; cursor off; blinking on
}

void Character1(void)
{
	unsigned int i;
	InitRW1603();
	SetDDRAMAddress(0x80);
	for(i=0x30;i<0x58;i++)
		WriteData(i);
	SetDDRAMAddress(0xc0);
	for(i=0x58;i<0x80;i++)
		WriteData(i);
}

void Character2(void)
{
	unsigned int i;
	InitRW1603();
	SetDDRAMAddress(0x80);
	for(i=0xa0;i<0xc8;i++)
		WriteData(i);
	SetDDRAMAddress(0xc0);
	for(i=0xc8;i<0xf0;i++)
		WriteData(i);
}

void CheckBoard(BYTE byParam1,BYTE byParam2)
{
	unsigned char  i;
	InitRW1603();
	SetCGRAMAddress(0x40);	// init CGRAM
	for(i=0;i<4;i++)
	{                                   // CGRAM 00
		WriteData(byParam1);               // 10101
		WriteData(byParam2);               // 01010
	}
	SetCGRAMAddress(0x48);
	for(i=0;i<4;i++)
	{                                   // CGRAM 01
		WriteData(byParam2);               // 01010
		WriteData(byParam1);               // 10101
	}
	SetCGRAMAddress(0x50);	// init CGRAM
	for(i=0;i<4;i++)
	{                                   // CGRAM 00
		WriteData(byParam1);               // 10101
		WriteData(byParam2);               // 01010
	}
	SetCGRAMAddress(0x58);
	for(i=0;i<4;i++)
	{                                   // CGRAM 01
		WriteData(byParam2);               // 01010
		WriteData(byParam1);               // 10101
	}

	SetDDRAMAddress(0x80);
	for(i=0;i<40;i++)
		if((i%2))WriteData(0);
		else WriteData(1);
	SetDDRAMAddress(0xc0);
	DELAY;
	for(i=0;i<40;i++)
		if((i%2))WriteData(2);
		else WriteData(3);
}

/*
void AllOFF(void)
{
	InitRW1603();
	DisplayControl(0x00);
}
 */